(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     50323,       1012]*)
(*NotebookOutlinePosition[     50968,       1034]*)
(*  CellTagsIndexPosition[     50924,       1030]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(Rowsum[\ mx_]\  := \t\n
      mx . \ Table[1, {\(Dimensions[mx]\)[\([2]\)]}, {1}]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\(DTMCSolve[mbe_] := \ \n
      Module[\ {isize, \ i}, \n\tisize = \(Dimensions[mbe]\)[\([1]\)]; \n\t
        i = \ IdentityMatrix[isize]; \n\ \ CTMCSolve[
          mbe - i]\n\t]\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(CTMCSolve\\)\\\" is similar to existing \
symbol \\\"\\!\\(DTMCSolve\\)\\\". \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], \
"Message"]
}, Open  ]],

Cell[BoxData[
    \(CTMCSolve[mbe_]\  := \n
      Module[\ {mx, isize, \ p0, i}, \n\tmx = mbe; \n\t
        isize = \(Dimensions[mx]\)[\([1]\)]; \n\tp0 = Table[0, {isize}]; \n\t
        p0[\([1]\)] = 1\ ; \n\tDo[mx[\([i, 1]\)] = 1, {i, \ isize}]; \n\t
        mx = \ Transpose[mx]; \n\tLinearSolve[mx, \ p0]\n\t]\)], "Input"],

Cell[BoxData[
    \(LagkCorrelation[d0_, d1_, k_] := \n
      Module[{e, n, \[Pi], d0i, \[Lambda]}, \n
        n\  = \ \(Dimensions[d1]\)[\([1]\)]; \n
        e = Table[1, {n}, {1}]; \[IndentingNewLine]\[Pi] = 
          CTMCSolve[d0 + d1]\ ; \n
        d0i = Inverse[\(-d0\)]; \[IndentingNewLine]\[Lambda] = \((\[Pi] . \ 
                d1\  . \ 
                e)\)[\([1]\)]; \[IndentingNewLine]\(\[Lambda]\ \ \((\[Pi] . \
MatrixPower[d0i . d1, k] . d0i . e)\)[\([1]\)] - 1\)\/\(2\ \[Lambda]\ \
\((\[Pi] . d0i . e)\)[\([1]\)] - 1\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(LagCorrelations[d0_, d1_] := \n
      Module[{e, n, \[Pi], 
          d0i, \[Lambda]}, \[IndentingNewLine]n\  = \ \(Dimensions[
              d1]\)[\([1]\)]; \[IndentingNewLine]e = 
          Table[1, {n}, {1}]; \[IndentingNewLine]\[Pi] = 
          CTMCSolve[d0 + d1]\ ; \[IndentingNewLine]d0i = 
          Inverse[\(-d0\)]; \[IndentingNewLine]\[Lambda] = \((\[Pi] . \ 
                d1\  . \ 
                e)\)[\([1]\)]; \[IndentingNewLine]res = {}; \
\[IndentingNewLine]For[i = 1, i \[LessEqual] 2  n - 3, 
          i = i + 1, \[IndentingNewLine]\[IndentingNewLine]res = 
            Append[res, \(\[Lambda]\ \ \((\[Pi] . MatrixPower[d0i . d1, i] . \
d0i . e)\)[\([1]\)] - 1\)\/\(2\ \[Lambda]\ \((\[Pi] . d0i . e)\)[\([1]\)] - 1\
\)]\[IndentingNewLine]]; \[IndentingNewLine]Return[
          res];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(\( (*\ d0, 
      d1\ alapjan\ szamitja\ az\ E \((X_  0^i, 
          X_  1^j)\)\ momentumok\ matrixszat\ \
*) \)\(\[IndentingNewLine]\)\(Lag1moms[d0_, d1_] := \n
      Module[{h, n, \[Pi], d0i, res, i, 
          j}, \[IndentingNewLine]n\  = \ \(Dimensions[
              d1]\)[\([1]\)]; \[IndentingNewLine]h = 
          Table[1, {n}, {1}]; \[IndentingNewLine]d0i = 
          Inverse[\(-d0\)]; \[IndentingNewLine]\[Pi] = 
          DTMCSolve[d0i . d1]\ ; \[IndentingNewLine]res = 
          Table[0, {n}, {n}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            n, \(i++\), \[IndentingNewLine]\(For[j = 1, 
              j \[LessEqual] 
                n, \(j++\), \[IndentingNewLine]res[\([i, 
                    j]\)] = \ \ \(\((i - 1)\)!\) \(\((j - 1)\)!\) \((\[Pi] . 
                        MatrixPower[d0i, i - 1] . d0i . d1 . 
                        MatrixPower[d0i, j - 1] . 
                        h)\)[\([1]\)]\[IndentingNewLine]];\)\
\[IndentingNewLine]]; \[IndentingNewLine]Return[
          res];\[IndentingNewLine]]\)\)\)], "Input"],

Cell[BoxData[
    \(\(\( (*calculate\ the\ first\ k\ mometns\ of\ a\ PH\ given\ with\ \((\
\[Alpha], T)\)*) \)\(\[IndentingNewLine]\)\(PHmoments[\[Alpha]_, T_, k_] := \n
      Module[{i, e, n, 
          res}, \[IndentingNewLine]n = \ \(Dimensions[
              T]\)[\([1]\)]; \[IndentingNewLine]res = {}; \
\[IndentingNewLine]e = Table[1, {n}, {1}]; \[IndentingNewLine]Ti = 
          Inverse[\(-T\)]; \[IndentingNewLine]For[i = 1, i \[LessEqual] k, 
          i = i + 1, \[IndentingNewLine]\(res = 
              Append[res, \(i!\)\ \((\[Alpha] . MatrixPower[Ti, i] . 
                        e)\)[\([1]\)]\ ];\)\[IndentingNewLine]]; \
\[IndentingNewLine]res\[IndentingNewLine]]\)\)\)], "Input"],

Cell[BoxData[
    \(Marginalmoments[d0_, d1_, k_] := \n
      Module[{i, e, n, \[Alpha], \[Pi], 
          d0i, \[Lambda]}, \[IndentingNewLine]n = \ \(Dimensions[
              d1]\)[\([1]\)]; \[IndentingNewLine]res = {}; \
\[IndentingNewLine]e = Table[1, {n}, {1}]; \[IndentingNewLine]\[Alpha] = 
          CTMCSolve[d0 + d1]\ ; \[IndentingNewLine]d0i = 
          Inverse[\(-d0\)]; \[IndentingNewLine]\[Pi] = 
          DTMCSolve[
            d0i . d1]\ ; \[IndentingNewLine]\[Lambda] = \((\[Alpha] . \ 
                d1\  . \ 
                e)\)[\([1]\)]; \[IndentingNewLine]Print[\ "\<\[Lambda]=\>", \
\[Lambda], "\< \[Pi]=\>", \[Pi], "\< \[Alpha]=\>", \[Alpha], "\< \[Alpha] d1=\
\>", \[Alpha] . d1]; \[IndentingNewLine]For[i = 1, i \[LessEqual] k, 
          i = i + 1, \[IndentingNewLine] (*\(res = 
                Append[res, \(i!\)\ \((\[Alpha] . d1 . MatrixPower[d0i, i] . 
                            e)\)[\([1]\)]/\[Lambda]];\)*) \[IndentingNewLine]\
\(res = Append[
                res, \(i!\)\ \((\[Pi] . MatrixPower[d0i, i] . 
                        e)\)[\([1]\)]];\)\[IndentingNewLine]]; \
\[IndentingNewLine]res\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Appie[rmom_, print_]\  := \n (*\ 
        input : \ 
          vector\ of\ reduced\ \(\(moments\ /\[Mu]_i\)/\(i!\)\)/\ 
                from\ 1\ to\ 2  m - 1\ *) \ \[IndentingNewLine] (*\ 
        output : \ 
          Appie' s\ ME\ \(representation : \ 
              matrix\ V\ and\ order\ n\)\ *) \ \[IndentingNewLine]Module[\ \
{rm, m, \ i, j, f, y, dd, nold, yold, k, q, d, \[Alpha], \[Beta], 
          n}, \n\ \ \ \ \ m = \(Dimensions[
              rmom]\)[\([1]\)]; \[IndentingNewLine]If[
          Mod[m, 2] == 
            0, \[IndentingNewLine]Print["\<Even number of moments, the last \
one is dropped !!\>"]; \[IndentingNewLine]rm = Drop[rmom, \(-1\)]; m = m/2, 
          rm = rmom; 
          m = Ceiling[m/2]\[IndentingNewLine]]; \[IndentingNewLine]rm = 
          Prepend[rm, 1]; \[IndentingNewLine]f = 
          Table[0, {2  m}, {1}]; \[IndentingNewLine]f[\([1, 1]\)] = 
          1; \[IndentingNewLine]y = 
          Table[0, {2  m}, {1}]; \[IndentingNewLine]dd = 
          Table[0, {2  m}, {2  m}]; \[IndentingNewLine]n = 
          0; \[IndentingNewLine]k = 0; \[IndentingNewLine]q = 
          1; \[IndentingNewLine]d = 
          Table[0, {m}]; \[IndentingNewLine]\[Alpha] = 
          Table[0, {m}, {m}]; \[IndentingNewLine]\[Beta] = 
          Table[0, {m}]; \[IndentingNewLine]For[i = 2, i \[LessEqual] 2  m, 
          dd[\([i, i - 1]\)] = 1; \(i++\)]; \[IndentingNewLine]For[i = 1, 
          i <= 2  m, \[IndentingNewLine] (*THEN*) \[IndentingNewLine]\[Rho] = 
            FullSimplify[
              q\ \((rm . f)\)[\([1]\)]\ ]; \[IndentingNewLine]nold = 
            n; \[IndentingNewLine]n = nold + 1; \[IndentingNewLine]yold = 
            y; \[IndentingNewLine]If[print, 
            Print["\<iter \>", i, "\< \[Rho]=\>", \[Rho], "\< n=\>", 
              n, \ "\< yold=\>", yold]]; \[IndentingNewLine]If[
            n > 0\  && \[Rho] \[NotEqual] 
                0\ , \[IndentingNewLine] (*THEN*) \[IndentingNewLine]If[
              k > 0, \[Beta][\([k]\)] = \[Rho]\/\((rm[\([1 + \
1]\)])\)\^\(d[\([k]\)] + n - 1\)]; \[IndentingNewLine]k = 
              k + 1; \[IndentingNewLine]d[\([k]\)] = 
              n; \[IndentingNewLine]n = \(-n\); \[IndentingNewLine]q = 
              q\/\[Rho]; \[IndentingNewLine]y = dd . f; \[IndentingNewLine]If[
              print, Print[i, "\< then: \[Beta]=\>", \[Beta], "\< k=\>", 
                k, "\< n=\>", n, "\< q=\>", 
                q\ ]], \[IndentingNewLine] (*ELSE*) \[IndentingNewLine]If[
              print, Print[i, "\< else: n=\>", n]]; \[IndentingNewLine]If[
              n \[LessEqual] 0, \[IndentingNewLine]j = 
                nold + d[\([k]\)] + 
                  1; \[IndentingNewLine]\[Alpha][\([k, 
                    j]\)] = \[Rho]\/\((rm[\([1 + 1]\)])\)\^\(j - 1\); \
\[IndentingNewLine]If[print, 
                Print[i\ , "\< else if: k+1=\>", k + 1, "\< j+1=\>", 
                  j + 1, \ "\< \[Alpha]=\>", \[Alpha]]]\[IndentingNewLine]], \
\[IndentingNewLine] (*UNDEFINED\ /
                  in\ case\ of\ symbolic\ \(\(analysis\)\(/\)\)\ \
*) \[IndentingNewLine]If[
              n > 0\ , \[IndentingNewLine] (*THEN*) \[IndentingNewLine]If[
                k > 0, \[Beta][\([k]\)] = \[Rho]\/\((rm[\([1 + 1]\)])\)\^\(d[\
\([k]\)] + n - 1\)]; \[IndentingNewLine]k = 
                k + 1; \[IndentingNewLine]d[\([k]\)] = 
                n; \[IndentingNewLine]n = \(-n\); \[IndentingNewLine]q = 
                q\/\[Rho]; \[IndentingNewLine]y = 
                dd . f; \[IndentingNewLine]If[print, 
                Print[i, "\< undefined then: \[Beta]=\>", \[Beta], "\< k=\>", 
                  k, "\< n=\>", n, "\< q=\>", 
                  q\ ]], \[IndentingNewLine] (*ELSE*) \[IndentingNewLine]If[
                print, Print[i, "\< else: n=\>", n]]; \[IndentingNewLine]If[
                n \[LessEqual] 0, \[IndentingNewLine]j = 
                  nold + d[\([k]\)] + 
                    1; \[IndentingNewLine]\[Alpha][\([k, 
                      j]\)] = \[Rho]\/\((rm[\([1 + 1]\)])\)\^\(j - 1\); \
\[IndentingNewLine]If[print, 
                  Print[i\ , "\< undefined else if: k+1=\>", 
                    k + 1, "\< j+1=\>", 
                    j + 1, \ "\< \[Alpha]=\>", \[Alpha]]]\[IndentingNewLine]]\
\[IndentingNewLine]]\[IndentingNewLine]]; \[IndentingNewLine]f = \ 
            dd . f - \[Rho]\ yold; \[IndentingNewLine]If[print, 
            Print["\<f=\>", 
              f]]; \[IndentingNewLine]\(i++\)]; \[IndentingNewLine]\
\[IndentingNewLine]If[print, 
          Print["\<m=\>", 
            m, "\< \[Beta]=\>", \[Beta], "\< \[Alpha]=\>", \[Alpha], "\< \
d=\>", d]]; \[IndentingNewLine]If[Sum[d[\([i]\)], {i, 1, m}] \[NotEqual] m, 
          Print["\<Insufficient matrix order !!!!\>"]]; \n\
\[IndentingNewLine]kk = 
          Table[0, {m}, {m}]; \[IndentingNewLine]kk[\([1, 1]\)] = 
          rm[\([2]\)]; \[IndentingNewLine]For[i = 1, i \[LessEqual] m - 1, 
          kk[\([i, i + 1]\)] = 
            rm[\([2]\)]; \(i++\)]; \[IndentingNewLine]\[IndentingNewLine]ind \
= d[\([1]\)]; \[IndentingNewLine]For[i = 2, 
          i \[LessEqual] m, \[IndentingNewLine]If[
            ind < m, \[IndentingNewLine]inc = 
              d[\([i]\)]; \[IndentingNewLine]If[\((ind = 
                    ind + inc)\) \[LessEqual] 
                m, \[IndentingNewLine]kk[\([ind, 
                    ind - inc - d[\([i - 1]\)] + 1]\)] = \[Beta][\([i - 
                      1]\)]; \[IndentingNewLine]For[j = 1, 
                j \[LessEqual] 
                  inc, \[IndentingNewLine]kk[\([ind, 
                      ind - j + 1]\)] = \[Alpha][\([i, 
                      j]\)]; \[IndentingNewLine]\(j++\)];\[IndentingNewLine]];\
\[IndentingNewLine]]; \[IndentingNewLine]\(i++\)]; \[IndentingNewLine]{kk, 
          m}\n\t]\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(yold\\)\\\" is similar to existing symbol \\\
\"\\!\\(nold\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(\(\(\ \)\( (*\ 
      Calculating\ the\ normalized\ moments\ from\ ordinary\ moments\ *) \)\(\
\[IndentingNewLine]\)\(\(moms2normmoms[\ 
        moms_]\)\(\ \)\(:=\)\(\n\)\(Module[\ {isize, \ i, \ normmoms\ , 
          m}, \[IndentingNewLine]isize = \(Dimensions[
              moms]\)[\([1]\)]; \[IndentingNewLine]normmoms = {}; \
\[IndentingNewLine]For[\ i = \ 2, 
          i <= \ isize, \ \ m = 
            moms[\([i]\)]\/\(moms[\([i - 1]\)]\ moms[\([1]\)]\); \
\[IndentingNewLine]normmoms = 
            Append[normmoms, 
              m]; \(i++\)]; \[IndentingNewLine]normmoms\n]\)\(\t\)\)\)\)], \
"Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\( (*\ 
      Calculating\ the\ reduced\ moments\ \[Mu]i/\(i!\)\ from\ ordinary\ \
moments\ *) \)\(\[IndentingNewLine]\)\(\(moms2reducedmoms[\ 
        moms_]\)\(\ \)\(:=\)\(\n\)\(Module[\ {isize, \ i, \ rmoms, 
          m\ }, \[IndentingNewLine]isize = \(Dimensions[
              moms]\)[\([1]\)]; \[IndentingNewLine]rmoms = {}; \
\[IndentingNewLine]For[\ i = \ 1, 
          i <= \ isize, \ \ m = 
            moms[\([i]\)]\/\(i!\); \[IndentingNewLine]rmoms = 
            Append[rmoms, 
              m]; \(i++\)]; \[IndentingNewLine]rmoms\n]\)\(\t\)\)\)\)], \
"Input"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(rmoms\\)\\\" is similar to existing symbols \
\\!\\({moms, rmom}\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*calculates\ the\ minimal\ PH\ representation\ based\ on\ 2  n - 
        1\ moments\ *) \)\(\ \)\(\[IndentingNewLine]\)\(\(PHMom2Minimal[
        mom_]\)\(:=\)\(\n\)\(Module[{size, kk, rmom, hh, e1, tt, gammai, 
          gamma, ee, gv, i, j}, \[IndentingNewLine]\[IndentingNewLine]rmom = 
          moms2reducedmoms[mom]; \[IndentingNewLine]{kk, size} = 
          Appie[rmom, FALSE]\ ; \[IndentingNewLine]\[IndentingNewLine]hh = 
          Table[1, {size}, {1}]; \[IndentingNewLine]e1 = 
          Table[0, {1}, {size}]; \[IndentingNewLine]e1[\([1, 1]\)] = 
          1; \[IndentingNewLine]\[IndentingNewLine]tt = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(For[j = 1, 
              j \[LessEqual] 
                i, \(j++\), \(tt[\([i, j]\)] = \ 
                  1;\)];\)]; \[IndentingNewLine]tti = 
          Inverse[tt]; \[IndentingNewLine] (*\(Print[tt // MatrixForm, 
              tti // MatrixForm];\)*) \[IndentingNewLine]\[IndentingNewLine]{\
gammai, ee} = 
          JordanDecomposition[tt . kk . tti]\ ; \[IndentingNewLine]gamma = 
          Inverse[gammai]; \[IndentingNewLine] (*\ 
          a\ sorokat\ 1 - re\ normalizalom\ *) \[IndentingNewLine]gv = 
          gamma . hh; \[IndentingNewLine]gv = 
          1/\(Transpose[gv]\)[\([1]\)]; \[IndentingNewLine]gamma = 
          DiagonalMatrix[gv] . 
            gamma; \[IndentingNewLine] (*\(Print["\<Jordanx mx ee=\>", 
              ee // MatrixForm, "\<, gamma=\>", 
              gamma // MatrixForm];\)*) \[IndentingNewLine]gammai = 
          Inverse[gamma]; \[IndentingNewLine]\[IndentingNewLine]Return[{\((e1 \
. gammai)\)[\([1]\)], ee}];\[IndentingNewLine]]\)\(\ \)\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(size\\)\\\" is similar to existing symbol \\\
\"\\!\\(isize\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gamma\\)\\\" is similar to existing symbols \
\\!\\({Gamma, gammai}\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(\(\( (*calculates\ the\ minimal\ PH\ representation\ based\ on\ 2  n - 
        1\ moments\ *) \)\(\ \)\(\[IndentingNewLine]\)\(\(PHMom2Appie[
        mom_]\)\(:=\)\(\n\)\(Module[{size, kk, rmom, hh, e1, tt, uu, i, 
          j}, \[IndentingNewLine]\[IndentingNewLine]rmom = 
          moms2reducedmoms[mom]; \[IndentingNewLine]{kk, size} = 
          Appie[rmom, FALSE]\ ; \[IndentingNewLine]\[IndentingNewLine]hh = 
          Table[1, {size}, {1}]; \[IndentingNewLine]e1 = 
          Table[0, {1}, {size}]; \[IndentingNewLine]e1[\([1, 1]\)] = 
          1; \[IndentingNewLine]\[IndentingNewLine]tt = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(For[j = 1, 
              j \[LessEqual] 
                i, \(j++\), \(tt[\([i, j]\)] = \ 
                  1;\)];\)]; \[IndentingNewLine]tti = 
          Inverse[tt]; \[IndentingNewLine] (*\(Print[tt // MatrixForm, 
              tti // MatrixForm];\)*) \[IndentingNewLine]\[IndentingNewLine]\
uu = Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(For[j = i, 
              j \[LessEqual] 
                size, \(j++\), \(uu[\([i, j]\)] = \ 
                  1/\((size - i + 1)\);\)];\)]; \[IndentingNewLine]uui = 
          Inverse[uu]; \[IndentingNewLine] (*\(Print[uu // MatrixForm, 
              uui // MatrixForm];\)*) \[IndentingNewLine]\[IndentingNewLine]\
Return[{\((e1)\)[\([1]\)] . tti . uu, 
            uui . tt . kk . tti . 
              uu}];\[IndentingNewLine]]\)\(\ \)\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*calculates\ the\ minimal\ MAP\ representation\ based\ on\ 2  n - 
        1\ moments\ and\ the\ matrix\ of\ the\ joint\ moments\ *) \)\(\ \)\(\
\[IndentingNewLine]\)\(\(MAPMom2Minimal[mom_, 
        nn_]\)\(:=\)\(\n\)\(Module[{size, hh, e1, gammav, gamma1, v, ee, ff, 
          mm, mv, i, j}, \[IndentingNewLine]\[IndentingNewLine]{v, ee} = 
          PHMom2Minimal[
            mom]; \[IndentingNewLine]size = \(Dimensions[
              v]\)[\([1]\)]; \[IndentingNewLine]\[IndentingNewLine]hh = 
          Table[1, {size}, {1}]; \[IndentingNewLine]e1 = 
          Table[0, {1}, {size}]; \[IndentingNewLine]e1[\([1, 1]\)] = 
          1; \[IndentingNewLine]\[IndentingNewLine]gammav = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(gammav[\([i]\)] = \(\((i - 1)\)!\)\ \ v . 
                  MatrixPower[ee, i - 1];\)]; \[IndentingNewLine]gamma1 = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(gamma1[\([i]\)] = \(\((i - 
                      1)\)!\)\ \ \(Transpose[
                    MatrixPower[ee, i - 1] . 
                      hh]\)[\([1]\)];\)]; \[IndentingNewLine]gamma1 = 
          Transpose[
            gamma1]; \[IndentingNewLine] (*\(Print[gammav // MatrixForm, 
              gamma1 // 
                MatrixForm];\)*) \[IndentingNewLine]\[IndentingNewLine]{mm, 
            ff} = JordanDecomposition[
            Inverse[gammav] . nn . 
              Inverse[gamma1]]\ ; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          az\ elso\ sor\ elemeit\ 1 - 
            re\ normalizalom\ *) \[IndentingNewLine]mv = 
          mm[\([1]\)]; \[IndentingNewLine]mv = 1/mv; \[IndentingNewLine]mm = 
          mm . DiagonalMatrix[
              mv]; \[IndentingNewLine]\[IndentingNewLine]Return[{ee, ff, 
            mm}];\[IndentingNewLine]]\)\(\ \)\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gammav\\)\\\" is similar to existing symbols \
\\!\\({gamma, gammai}\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(\(\( (*calculates\ the\ minimal\ MAP\ representation\ based\ on\ 2  n - 
        1\ moments\ and\ the\ matrix\ of\ the\ joint\ moments\ *) \)\(\ \)\(\
\[IndentingNewLine]\)\(\(MAPMom2ERrep[mom_, 
        nn_]\)\(:=\)\(\n\)\(Module[{size, hh, e1, gammav, gamma1, v, ee, ff, 
          mm, mv, i, j}, \[IndentingNewLine]\[IndentingNewLine]{v, ee} = 
          PHMom2Minimal[
            mom]; \[IndentingNewLine]size = \(Dimensions[
              v]\)[\([1]\)]; \[IndentingNewLine]\[IndentingNewLine]hh = 
          Table[1, {size}, {1}]; \[IndentingNewLine]e1 = 
          Table[0, {1}, {size}]; \[IndentingNewLine]e1[\([1, 1]\)] = 
          1; \[IndentingNewLine]\[IndentingNewLine]gammav = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(gammav[\([i]\)] = \(\((i - 1)\)!\)\ \ v . 
                  MatrixPower[ee, i - 1];\)]; \[IndentingNewLine]gamma1 = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(gamma1[\([i]\)] = \(\((i - 
                      1)\)!\)\ \ \(Transpose[
                    MatrixPower[ee, i - 1] . 
                      hh]\)[\([1]\)];\)]; \[IndentingNewLine]gamma1 = 
          Transpose[
            gamma1]; \[IndentingNewLine] (*\(Print[gammav // MatrixForm, 
              gamma1 // 
                MatrixForm];\)*) \[IndentingNewLine]\[IndentingNewLine]Return[\
{ee, Inverse[gammav] . nn . 
              Inverse[gamma1]}];\[IndentingNewLine]]\)\(\ \)\)\)\)], "Input"],

Cell[BoxData[
    \(\(\( (*calculates\ the\ Apprie\ MAP\ representation\ based\ on\ 2  n - 
        1\ moments\ and\ the\ matrix\ of\ the\ joint\ moments\ *) \)\(\ \)\(\
\[IndentingNewLine]\)\(\(MAPMom2Appie[mom_, 
        nn_]\)\(:=\)\(\n\)\(Module[{size, hh, gammav, gamma1, v, ee, h0, i, 
          j}, \[IndentingNewLine]\[IndentingNewLine]{v, ee} = 
          PHMom2Appie[
            mom]; \[IndentingNewLine]size = \(Dimensions[
              v]\)[\([1]\)]; \[IndentingNewLine]\[IndentingNewLine]hh = 
          Table[1, {size}, {1}]; \[IndentingNewLine]\[IndentingNewLine]gammav \
= Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(gammav[\([i]\)] = \(\((i - 1)\)!\)\ \ v . 
                  MatrixPower[ee, i - 1];\)]; \[IndentingNewLine]gamma1 = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(gamma1[\([i]\)] = \(\((i - 
                      1)\)!\)\ \ \(Transpose[
                    MatrixPower[ee, i - 1] . 
                      hh]\)[\([1]\)];\)]; \[IndentingNewLine]gamma1 = 
          Transpose[
            gamma1]; \[IndentingNewLine] (*\(Print[gammav // MatrixForm, 
              gamma1 // MatrixForm];\)*) \[IndentingNewLine]h0 = \ 
          Inverse[\(-ee\)]; \[IndentingNewLine]\[IndentingNewLine] (*\ \(-h0^\
\(-1\)\)\ es\ p\ visszaadasa*) \[IndentingNewLine] (*\ \(Return[{ee, 
                Inverse[gammav] . nn . 
                  Inverse[gamma1]}];\)\ *) \[IndentingNewLine] (*\ 
          h0\ es\ h1\ visszaadasa\ *) \[IndentingNewLine]Return[{h0, \(-h0 . 
                Inverse[gammav] . nn . 
                Inverse[
                  gamma1]\)}];\[IndentingNewLine]]\)\(\ \)\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(matrixmi[dd0_, 
          dd1_] := \[IndentingNewLine]Module[\[IndentingNewLine]{size, hh, 
            e1, d0i, p, gamma, gammai, gv, ee, ff, deltai, 
            delta}, \[IndentingNewLine]\[IndentingNewLine]size = \(Dimensions[
                dd0]\)[\([1]\)]; \[IndentingNewLine]hh = 
            Table[1, {size}, {1}]; \[IndentingNewLine]e1 = 
            Table[0, {1}, {size}]; \[IndentingNewLine]e1[\([1, 1]\)] = 
            1; \[IndentingNewLine]\[IndentingNewLine]d0i = \(-Inverse[
                dd0]\); \[IndentingNewLine]p = 
            d0i . dd1; \[IndentingNewLine]\[IndentingNewLine]{gammai, ee} = 
            JordanDecomposition[d0i]\ ; \[IndentingNewLine]gamma = 
            Inverse[gammai]; \[IndentingNewLine] (*\ 
            a\ sorokat\ 1 - re\ normalizalom\ *) \[IndentingNewLine]gv = 
            gamma . hh; \[IndentingNewLine]gv = 
            1/\(Transpose[gv]\)[\([1]\)]; \[IndentingNewLine]gamma = 
            DiagonalMatrix[gv] . 
              gamma; \[IndentingNewLine]\[IndentingNewLine] \
(*\(Print["\<Jordanx mx ee=\>", ee // MatrixForm, "\<, gamma=\>", 
                gamma // MatrixForm];\)*) \[IndentingNewLine]gammai = 
            Inverse[gamma]; \[IndentingNewLine] (*\ 
            d0i = gammai . ee . 
                gamma\ *) \[IndentingNewLine]\[IndentingNewLine]{deltai, 
              ff} = JordanDecomposition[p]; \[IndentingNewLine]delta = 
            Inverse[deltai]; \[IndentingNewLine] (*\(Print["\<Jordan mx \
ff=\>", ff // MatrixForm, "\<, deltai=\>", 
                deltai // MatrixForm];\)*) \[IndentingNewLine] (*\ \(p = 
                deltai . ff . 
                  delta;\)\ *) \[IndentingNewLine]\[IndentingNewLine] (*\ 
            NORMALIZING\ M^\(-1\)\ \ *) \[IndentingNewLine]gv = 
            e1 . gamma . 
              deltai; \[IndentingNewLine]gv = \((1/
                  gv)\)[\([1]\)]; \[IndentingNewLine]deltai = \ 
            deltai . DiagonalMatrix[gv]; \[IndentingNewLine]delta = 
            Inverse[deltai]; \[IndentingNewLine]\[IndentingNewLine] \
(*\(Print["\<m^-1 mx ff=\>", 
                gamma . deltai // 
                  MatrixForm];\)*) \[IndentingNewLine]\[IndentingNewLine]{ee, 
            ff, gamma . deltai}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(delta\\)\\\" is similar to existing symbol \
\\\"\\!\\(deltai\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(\(matrix2ERrep[dd0_, 
          dd1_] := \[IndentingNewLine]Module[\[IndentingNewLine]{size, hh, 
            e1, d0i, p, gamma, gammai, gv, ee, ff, deltai, 
            delta}, \[IndentingNewLine]\[IndentingNewLine]size = \(Dimensions[
                dd0]\)[\([1]\)]; \[IndentingNewLine]hh = 
            Table[1, {size}, {1}]; \[IndentingNewLine]e1 = 
            Table[0, {1}, {size}]; \[IndentingNewLine]e1[\([1, 1]\)] = 
            1; \[IndentingNewLine]\[IndentingNewLine]d0i = \(-Inverse[
                dd0]\); \[IndentingNewLine]p = 
            d0i . dd1; \[IndentingNewLine]\[IndentingNewLine]{gammai, ee} = 
            JordanDecomposition[d0i]\ ; \[IndentingNewLine]gamma = 
            Inverse[gammai]; \[IndentingNewLine] (*\ 
            a\ sorokat\ 1 - re\ normalizalom\ *) \[IndentingNewLine]gv = 
            gamma . hh; \[IndentingNewLine]gv = 
            1/\(Transpose[gv]\)[\([1]\)]; \[IndentingNewLine]gamma = 
            DiagonalMatrix[gv] . 
              gamma; \[IndentingNewLine]\[IndentingNewLine] \
(*\(Print["\<Jordanx mx ee=\>", ee // MatrixForm, "\<, gamma=\>", 
                gamma // MatrixForm];\)*) \[IndentingNewLine]gammai = 
            Inverse[gamma]; \[IndentingNewLine] (*\ 
            d0i = gammai . ee . 
                gamma\ *) \[IndentingNewLine]\[IndentingNewLine]{ee, 
            gamma . p . gammai}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(Trafo[h0_, h1_, cum_, i_, j_, a_]\  := \n
      Module[\ {bb, 
          size}, \[IndentingNewLine]size = \(Dimensions[
              h0]\)[\([1]\)]; \[IndentingNewLine]bb = 
          IdentityMatrix[size]; \[IndentingNewLine]bb[\([i, j]\)] = 
          a; \[IndentingNewLine]bb[\([i, i]\)] = 
          1 - a; \[IndentingNewLine]Return[{Inverse[bb] . h0 . bb, 
            Inverse[bb] . h1 . bb, cum . bb}]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(Error[x_] := 
        Module[\ {drift}, drift = 0.5; \((x - drift)\)^2];\)\)\)], "Input"],

Cell[BoxData[
    \(\(Error[x_] := 
        Module[\ {c}, c = 15; \[ExponentialE]\^\(\(-c\)\ x\)];\)\)], "Input"],

Cell[BoxData[
    \(\(Error[x_] := \[ExponentialE]\^\(-\((x - 1)\)\^3\);\)\)], "Input"],

Cell[BoxData[
    \(\(Error[x_] := 
        Which[x < 0, 5 - x, x \[GreaterEqual] 0, x];\)\)], "Input"],

Cell[BoxData[
    \(\(Error[x_] := 
        Which[x < 0, \[ExponentialE]\^\(-\((x)\)\^3\) - 1, 
          x \[GreaterEqual] 0, 0];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Errorc[x_, c_] := \[ExponentialE]\^\(\(-c\)\ x\);\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(Errorc\\)\\\" is similar to existing symbol \
\\\"\\!\\(Error\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(\(Errorc[x_, c_] := \[ExponentialE]\^\(-\ x\^c\);\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Measure[h0_, h1_]\  := \n
      Module[\ {i, j, size, 
          sum}, \[IndentingNewLine]size = \(Dimensions[
              h0]\)[\([1]\)]; \[IndentingNewLine]sum = 
          0; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \(For[j = 1, 
              j \[LessEqual] 
                size, \(j++\), \[IndentingNewLine]\(If[i \[NotEqual] j, 
                  sum += Error[
                      h0[\([i, j]\)]\ \ ]\ ];\)];\)]; \[IndentingNewLine]For[
          i = 1, i \[LessEqual] 
            size, \(i++\), \(For[j = 1, 
              j \[LessEqual] 
                size, \(j++\), \[IndentingNewLine]\(sum += 
                  Error[h1[\([i, 
                        j]\)]\ \ ];\)];\)]; \[IndentingNewLine]Return[
          sum]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(sum\\)\\\" is similar to existing symbol \
\\\"\\!\\(Sum\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(MeasureMin[h0_, h1_, cum_, a_]\  := \n
      Module[\ {i, j, k, size, m, \ mbe, h0u, h1u, cumu, min, mini, minj, 
          mina}, \[IndentingNewLine]mbe = 
          Measure[h0, h1]; \[IndentingNewLine]min = mbe; mini = 0; 
        minj = 0; \[IndentingNewLine]size = \(Dimensions[
              h0]\)[\([1]\)]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] 
            size, \(i++\), \[IndentingNewLine]\(For[j = 1, 
              j \[LessEqual] 
                size, \(j++\), \[IndentingNewLine]\(If[
                  i \[NotEqual] j, \[IndentingNewLine]{h0u, h1u, cumu} = 
                    Trafo[h0, h1, cum, i, j, a]; \[IndentingNewLine]If[\ 
                    CheckMAP[h0u, h1u], 
                    Print["\<MAP REPRESEANTAION !!!!!\>"]; 
                    Return[{h0u, h1u, cumu, False}];]; \[IndentingNewLine]m = 
                    Measure[h0u, h1u]; \[IndentingNewLine]If[m\  < min, 
                    mini = i; minj = j; min = m\ ; 
                    mina = a]; \[IndentingNewLine]\[IndentingNewLine]{h0u, 
                      h1u, cumu} = 
                    Trafo[h0, h1, cum, i, j, \(-a\)]; \[IndentingNewLine]If[\ 
                    CheckMAP[h0u, h1u], 
                    Print["\<MAP REPRESEANTAION !!!!!\>"]; 
                    Return[{h0u, h1u, cumu, False}];]; \[IndentingNewLine]m = 
                    Measure[h0u, h1u]; \[IndentingNewLine]If[m\  < min, 
                    mini = i; minj = j; min = m\ ; 
                    mina = \(-a\)];\[IndentingNewLine]];\)\[IndentingNewLine]]\
;\)\[IndentingNewLine]]; \[IndentingNewLine]If[
          mini \[NotEqual] 0, \[IndentingNewLine]{h0u, h1u, cumu} = 
            Trafo[h0, h1, cum, mini, minj, 
              mina]\ ; \[IndentingNewLine] (*\(Print["\<i=\>", 
                mini, "\< j=\>", minj, "\< d=\>", \ 
                Measure[h0u, h1u], "\< a=\>", 
                mina];\)*) \[IndentingNewLine]Return[{h0u, h1u, cumu, 
              True}], \[IndentingNewLine] (*\(Print["\<i=\>", 
                mini, "\< j=\>", minj, "\< d=\>", \ mbe\ , "\< a=\>", 
                a];\)*) \[IndentingNewLine]\(Return[{h0, h1, cum, 
                False}];\)\[IndentingNewLine]];\[IndentingNewLine]]\)], \
"Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(cumu\\)\\\" is similar to existing symbol \\\
\"\\!\\(cum\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(min\\)\\\" is similar to existing symbol \
\\\"\\!\\(Min\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(mini\\)\\\" is similar to existing symbol \\\
\"\\!\\(min\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(General :: \\\"spell1\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(minj\\)\\\" is similar to existing symbols \
\\!\\({min, mini}\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(mina\\)\\\" is similar to existing symbols \
\\!\\({min, mini, minj}\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(CheckMAP[h0_, h1_]\  := \n
      Module[\ {i, j, myh0, 
          size}, \[IndentingNewLine]size = \(Dimensions[
              h0]\)[\([1]\)]; \[IndentingNewLine]myh0 = 
          h0; \[IndentingNewLine]For[k = 1, k \[LessEqual] size, \(k++\), 
          myh0[\([k, k]\)] = 0]; \[IndentingNewLine]If[\ 
          Min[h1] \[GreaterEqual] 0\  && \ 
            Min[myh0] \[GreaterEqual] 0, \[IndentingNewLine]Return[True], \ 
          Return[False]];\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Checka[hh_, i_, j_]\  := \n
      Module[\ {bb, size, 
          a}, \[IndentingNewLine]size = \(Dimensions[
              hh]\)[\([1]\)]; \[IndentingNewLine]bb = 
          IdentityMatrix[size]; \[IndentingNewLine]bb[\([i, j]\)] = 
          a; \[IndentingNewLine]bb[\([i, i]\)] = 
          1 - a; \[IndentingNewLine]Return[
          Solve[\((Inverse[bb] . hh . bb)\)[\([i, j]\)]\  \[Equal] 0, 
            a]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(Checka\\)\\\" is similar to existing symbol \
\\\"\\!\\(Check\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(RandomPH[size_, \ seed_]\  := \n
      Module[\ {i, j, \ d0\ , v}, \[IndentingNewLine]If[seed \[NotEqual] 0, 
          SeedRandom[seed]]; \[IndentingNewLine]d0 = 
          Table[0, {size}, {size}]; \[IndentingNewLine]v = 
          Table[0, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] size, \(i++\), \[IndentingNewLine]rowsum = 
            0; \[IndentingNewLine]For[j = 1, 
            j \[LessEqual] 
              size, \(j++\), \[IndentingNewLine]\(If[i \[NotEqual] j, 
                d0[\([i, j]\)] = Random[\ ]; 
                rowsum += 
                  d0[\([i, j]\)]\ \ ];\)]; \[IndentingNewLine]d0[\([i, 
                i]\)] = \(-rowsum\) - 
              Random[\ ];\[IndentingNewLine]]; \[IndentingNewLine]rowsum = 
          0; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] size, \(i++\), \[IndentingNewLine]v[\([i]\)] = 
            Random[\ ]; 
          rowsum += v[\([i]\)]\ ]; \[IndentingNewLine]Return[{v/rowsum, 
            d0}]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(rowsum\\)\\\" is similar to existing symbol \
\\\"\\!\\(Rowsum\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(RandomMAP[size_, \ seed_]\  := \n
      Module[\ {i, j, \ d0, d1}, \[IndentingNewLine]If[seed \[NotEqual] 0, 
          SeedRandom[seed]]; \[IndentingNewLine]d0 = 
          Table[0, {size}, {size}]; \[IndentingNewLine]d1 = 
          d0; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] size, \(i++\), \[IndentingNewLine]rowsum = 
            0; \[IndentingNewLine]For[j = 1, 
            j \[LessEqual] 
              size, \(j++\), \[IndentingNewLine]\(If[i \[NotEqual] j, 
                d0[\([i, j]\)] = Random[\ ]; 
                rowsum += d0[\([i, j]\)]\ \ ];\)]; \[IndentingNewLine]For[
            j = 1, j \[LessEqual] 
              size, \(j++\), \[IndentingNewLine]d1[\([i, j]\)] = Random[\ ]; 
            rowsum += d1[\([i, j]\)]\ ]; \[IndentingNewLine]d0[\([i, 
                i]\)] = \(-rowsum\);\[IndentingNewLine]]; \
\[IndentingNewLine]Return[{d0, d1}]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(RandomB[size_, seed_]\  := \n
      Module[\ {i, j, bb, bbi}, \[IndentingNewLine]If[seed \[NotEqual] 0, 
          SeedRandom[seed]]; \[IndentingNewLine]bb = 
          Table[0, {size}, {size}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] size, \(i++\), \[IndentingNewLine]sorsum = 
            0; \[IndentingNewLine]For[j = 1, 
            j \[LessEqual] size - 1, \(j++\), bb[\([i, j]\)] = Random[\ ]; 
            sorsum += bb[\([i, j]\)]\ ]\ ; \[IndentingNewLine]bb[\([i, 
                size]\)] = 
            1 - sorsum;\[IndentingNewLine]]; \[IndentingNewLine]Return[
          bb];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(RandomB\\)\\\" is similar to existing symbol \
\\\"\\!\\(Random\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell[BoxData[
    \(RandomTrafo[d0_, \ d1_, seed_]\  := \n
      Module[\ {i, j, \ size, bb, 
          bbi}, \[IndentingNewLine]size = \(Dimensions[
              d0]\)[\([1]\)]; \[IndentingNewLine]bb = 
          RandomB[size, seed]; \[IndentingNewLine]bbi = 
          Inverse[bb]; \[IndentingNewLine]Return[{bbi . d0 . bb, 
            bbi . d1 . bb}];\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ \ Calculates\ the\ He\ representation\ from\ any\ order\ 3\ ME\
\ representation\ *) \)\(\[IndentingNewLine]\)\(HeRepresentation[v_, 
          h0_]\  := \nModule[\ {ii, \[Lambda], a1, a2, a3, x1, x2, x3, 
            x13, \[Gamma]u, \[Gamma]0, \[Gamma]l, \[Phi], f, p1, p2, p3, 
            p}, \[IndentingNewLine]\[IndentingNewLine]If[\(Dimensions[
                  h0]\)[\([1]\)]\  \[NotEqual] 3, 
            Print["\<Dimension \[NotEqual] 3 !!! \>"]; 
            Return[]\ ]; \[IndentingNewLine]\[IndentingNewLine]ii = 
            IdentityMatrix[
              3]; \[IndentingNewLine]\[Lambda] = \(-Eigenvalues[
                h0]\); \[IndentingNewLine]a0 = \[Lambda][\([1]\)]\ \[Lambda][\
\([2]\)]\ \[Lambda][\([3]\)]\ ; \[IndentingNewLine]a1 = \[Lambda][\([1]\)]\ \
\[Lambda][\([2]\)]\  + \ \[Lambda][\([1]\)]\ \[Lambda][\([3]\)]\  + \ \
\[Lambda][\([2]\)]\ \[Lambda][\([3]\)]; \[IndentingNewLine]a2 = \
\[Lambda][\([1]\)]\  + \ \[Lambda][\([2]\)]\  + \ \ \[Lambda][\([3]\)]; \
\[IndentingNewLine]{a0, a1, a2} = 
            Re[{a0, a1, a2}]; \[IndentingNewLine]\[IndentingNewLine]f[
              x_] := \ x^3 + a2\ \ x^2 + a1\ x + 
              a0; \[IndentingNewLine]\[Gamma]u = \((a2 + 
                  2\ \@\(a2^2 - 3\ a1\))\)/
              3; \[IndentingNewLine]\[Gamma]0 = \((a2 + \ \@\(a2^2 - 3\ a1\))\
\)/3; \[IndentingNewLine]\[Phi] = 
            Max[\(-h0[\([1, 1]\)]\), \ \(-h0[\([2, 2]\)]\), \ \(-h0[\([3, 
                    3]\)]\)\ ]; \[IndentingNewLine]\[Phi] = 0; \  (*\ 
            itt\ elterek\ a\ He\ \(\(cikktol\ !!\)!!\)\ \
*) \[IndentingNewLine]If[\[Lambda][\([1]\)] \[Element] \ 
              Reals, \[Gamma]l = \[Lambda][\([1]\)]; 
            x1 = Max[\[Phi], \[Lambda][\([1]\)]], \[Gamma]l = \[Gamma]0; 
            x1 = Max[\[Phi], \[Gamma]0]]; \[IndentingNewLine]\
\[IndentingNewLine]x13 = \(\(-f[\(-x1\)]\)\/\(a0 - f[\(-x1\)]\)\) 
              x1; \[IndentingNewLine]x2 = \((a2 - 
                  x1 + \@\(\((a2 - x1)\)\^2 - 4 \((x1^2\  - \ a2\ x1\  + \
a1)\)\))\)/2; \[IndentingNewLine]x3 = \((a2 - 
                  x1 - \@\(\((a2 - x1)\)\^2 - 4 \((x1^2\  - \ a2\ x1\  + \
a1)\)\))\)/2; \[IndentingNewLine]\[IndentingNewLine]p1 = \(-\ 
                h0 . {{1}, {1}, {1}}\)/\((x1 - x13)\); 
          p1 = \(Transpose[
                p1]\)[\([1]\)]; \[IndentingNewLine]p2 = \(\(-\((x1\ ii\  + \ 
                        h0)\) . h0 . {{1}, {1}, {1}}\)/\((x1 - x13)\)\)/x2; 
          p2 = \(Transpose[
                p2]\)[\([1]\)]; \[IndentingNewLine]p3 = \(\(\(-\((x2\ ii\  + \
\ h0)\) . \((x1\ ii\  + \ h0)\) . h0 . {{1}, {1}, {1}}\)/\((x1 - x13)\)\)/
                x2\)/x3; 
          p3 = \(Transpose[p3]\)[\([1]\)]; \[IndentingNewLine]p = 
            Transpose[{p1, p2, p3}]; \[IndentingNewLine]Return[{v . 
                p, {{\(-x1\), 0, x13}, {x2, \(-x2\), 0}, {0, 
                  x3, \(-x3\)}}}];\[IndentingNewLine]];\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(\[Gamma]l\\)\\\" is similar to existing \
symbol \\\"\\!\\(\[Gamma]u\\)\\\". \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], \
"Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(MEP2MAP[h0in_, \ h1in_]\  := \n
      Module[\ {gsum, sum, \ n, \ h0, h1, \ csokken, \ n1, n2, n3, \ size, 
          cum}, \[IndentingNewLine]size = \(Dimensions[
              h0in]\)[\([1]\)]; \[IndentingNewLine]cum = 
          IdentityMatrix[size]; \[IndentingNewLine]h0 = h0in; \ h1 = h1in; 
        gsum = 0; \[IndentingNewLine]n1 = 10; \  (*\ 
          a - t\ csokkentem\ 2^\(-1\)\ tol\ 2^\(-n1\) - 
            ig\ *) \[IndentingNewLine]n2 = 2; \  (*\ 
          minden\ a - ra\ n2\ kort\ fut\ *) \[IndentingNewLine]n3 = 
          500; \  (*\ 
          celfuggvenyre\ max\ n3\ iteraciot\ csinal\ *) \[IndentingNewLine]\
\[IndentingNewLine]a = 1. ; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] n1, \(i++\), \[IndentingNewLine]a = 
            a/2; \[IndentingNewLine]For[j = 1, 
            j \[LessEqual] n2, \(j++\), \[IndentingNewLine]sum = 
              0; \[IndentingNewLine]Error[
                x_] := \[ExponentialE]\^\(\(-100\)\ x\); \
\[IndentingNewLine]csokken = True; \ 
            n = 0; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< initial d=\>", Measure[h0, h1], "\< a=\>", 
              a]; \[IndentingNewLine]While[
              csokken && \((n < n3)\), {h0, h1, cum, csokken} = 
                MeasureMin[h0, h1, cum, a]; n += 1\ ]; \[IndentingNewLine]If[
              CheckMAP[h0, 
                h1], \[IndentingNewLine]Print["\<Number of all \
iterations:\>", \ gsum + n, "\< error fv=\>", Error[x], "\< a=\>", 
                a, \ "\< n=\>", 
                n]; \ \[IndentingNewLine]Return[{h0, 
                  h1}]]; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< d=\>", Measure[h0, h1], "\< n=\>", 
              n - 1, "\< a=\>", a, \ \ "\< h0=\>", h0, "\< h1=\>", 
              h1]; \[IndentingNewLine]sum += 
              n - 1; \[IndentingNewLine]\[IndentingNewLine]Error[
                x_] := \[ExponentialE]\^\(\(-1000\)\ x\); \
\[IndentingNewLine]csokken = True; \ 
            n = 0; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< initial d=\>", Measure[h0, h1], "\< a=\>", 
              a]; \[IndentingNewLine]While[
              csokken && \((n < n3)\), {h0, h1, cum, csokken} = 
                MeasureMin[h0, h1, cum, a]; n += 1\ ]; \[IndentingNewLine]If[
              CheckMAP[h0, 
                h1], \[IndentingNewLine]Print["\<Number of all \
iterations:\>", \ gsum + n, "\< error fv=\>", Error[x], "\< a=\>", 
                a, \ "\< n=\>", 
                n]; \ \[IndentingNewLine]Return[{h0, 
                  h1}]]; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< d=\>", Measure[h0, h1], "\< n=\>", 
              n - 1, "\< a=\>", a, \ \ "\< h0=\>", h0, "\< h1=\>", 
              h1]; \[IndentingNewLine]sum += 
              n - 1; \[IndentingNewLine]\[IndentingNewLine]Error[
                x_] := \[ExponentialE]\^\(\(-2\)\ x\); \
\[IndentingNewLine]csokken = True; \ 
            n = 0; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< initial d=\>", Measure[h0, h1], "\< a=\>", 
              a]; \[IndentingNewLine]While[
              csokken && \((n < n3)\), {h0, h1, cum, csokken} = 
                MeasureMin[h0, h1, cum, a]; n += 1\ ]; \[IndentingNewLine]If[
              CheckMAP[h0, 
                h1], \[IndentingNewLine]Print["\<Number of all \
iterations:\>", \ gsum + n, "\< error fv=\>", Error[x], "\< a=\>", 
                a, \ "\< n=\>", 
                n]; \ \[IndentingNewLine]Return[{h0, 
                  h1}]]; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< d=\>", Measure[h0, h1], "\< n=\>", 
              n - 1, "\< a=\>", a, \ \ "\< h0=\>", h0, "\< h1=\>", 
              h1]; \[IndentingNewLine]sum += 
              n - 1; \[IndentingNewLine]\[IndentingNewLine]Error[
                x_] := \[ExponentialE]\^\(-\((x - 1)\)\^3\); \
\[IndentingNewLine]csokken = True; 
            n = 0; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< initial d=\>", Measure[h0, h1], "\< a=\>", 
              a]; \[IndentingNewLine]While[
              csokken && \((n < n3)\), {h0, h1, cum, csokken} = 
                MeasureMin[h0, h1, cum, a]\ ; n += 1]; \[IndentingNewLine]If[
              CheckMAP[h0, 
                h1], \[IndentingNewLine]Print["\<Number of all \
iterations:\>", \ gsum + n, "\< error fv=\>", Error[x], "\< a=\>", 
                a, \ "\< n=\>", n]; \ 
              Return[{h0, h1}]]; \[IndentingNewLine]Print["\<error fv=\>", 
              Error[x], "\< d=\>", Measure[h0, h1], "\< n=\>", 
              n - 1, "\< a=\>", a, \ \ "\< h0=\>", h0, "\< h1=\>", 
              h1]; \[IndentingNewLine]sum += 
              n - 1; \[IndentingNewLine]Print["\<Number of iterations:\>", \ 
              sum]; \[IndentingNewLine]gsum += 
              sum;\[IndentingNewLine]];\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]Print["\<No MAP representation is found \
in \>", \ gsum, \ "\< iterations !!!\>"]; \[IndentingNewLine]Return[{0, 
            0}];\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gsum\\)\\\" is similar to existing symbol \\\
\"\\!\\(sum\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 949}},
WindowSize->{854, 602},
WindowMargins->{{20, Automatic}, {Automatic, 20}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 114, 2, 50, "Input"],

Cell[CellGroupData[{
Cell[1893, 57, 224, 4, 130, "Input"],
Cell[2120, 63, 368, 6, 22, "Message"]
}, Open  ]],
Cell[2503, 72, 325, 5, 210, "Input"],
Cell[2831, 79, 568, 10, 208, "Input"],
Cell[3402, 91, 859, 15, 310, "Input"],
Cell[4264, 108, 1092, 21, 310, "Input"],
Cell[5359, 131, 698, 11, 250, "Input"],
Cell[6060, 144, 1167, 20, 330, "Input"],

Cell[CellGroupData[{
Cell[7252, 168, 5796, 101, 1866, "Input"],
Cell[13051, 271, 356, 5, 22, "Message"]
}, Open  ]],
Cell[13422, 279, 634, 13, 209, "Input"],

Cell[CellGroupData[{
Cell[14081, 296, 602, 12, 207, "Input"],
Cell[14686, 310, 356, 5, 22, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15079, 320, 1768, 29, 550, "Input"],
Cell[16850, 351, 357, 5, 22, "Message"],
Cell[17210, 358, 359, 5, 22, "Message"]
}, Open  ]],
Cell[17584, 366, 1616, 28, 470, "Input"],

Cell[CellGroupData[{
Cell[19225, 398, 1960, 34, 570, "Input"],
Cell[21188, 434, 360, 5, 22, "Message"]
}, Open  ]],
Cell[21563, 442, 1572, 27, 430, "Input"],
Cell[23138, 471, 1772, 30, 450, "Input"],

Cell[CellGroupData[{
Cell[24935, 505, 2276, 38, 770, "Input"],
Cell[27214, 545, 359, 5, 22, "Message"]
}, Open  ]],
Cell[27588, 553, 1415, 23, 510, "Input"],
Cell[29006, 578, 460, 8, 170, "Input"],
Cell[29469, 588, 119, 2, 30, "Input"],
Cell[29591, 592, 113, 2, 30, "Input"],
Cell[29707, 596, 87, 1, 33, "Input"],
Cell[29797, 599, 103, 2, 30, "Input"],
Cell[29903, 603, 145, 3, 34, "Input"],

Cell[CellGroupData[{
Cell[30073, 610, 86, 1, 30, "Input"],
Cell[30162, 613, 359, 5, 22, "Message"]
}, Open  ]],
Cell[30536, 621, 84, 1, 31, "Input"],

Cell[CellGroupData[{
Cell[30645, 626, 827, 18, 210, "Input"],
Cell[31475, 646, 354, 5, 22, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[31866, 656, 2244, 38, 570, "Input"],
Cell[34113, 696, 355, 5, 22, "Message"],
Cell[34471, 703, 354, 5, 22, "Message"],
Cell[34828, 710, 355, 5, 22, "Message"],
Cell[35186, 717, 333, 5, 22, "Message"],
Cell[35522, 724, 354, 5, 22, "Message"],
Cell[35879, 731, 360, 5, 22, "Message"]
}, Open  ]],
Cell[36254, 739, 502, 9, 170, "Input"],

Cell[CellGroupData[{
Cell[36781, 752, 466, 9, 170, "Input"],
Cell[37250, 763, 359, 5, 22, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37646, 773, 1041, 19, 330, "Input"],
Cell[38690, 794, 360, 5, 22, "Message"]
}, Open  ]],
Cell[39065, 802, 936, 16, 310, "Input"],

Cell[CellGroupData[{
Cell[40026, 822, 656, 11, 230, "Input"],
Cell[40685, 835, 361, 5, 22, "Message"]
}, Open  ]],
Cell[41061, 843, 389, 7, 150, "Input"],

Cell[CellGroupData[{
Cell[41475, 854, 2938, 47, 657, "Input"],
Cell[44416, 903, 368, 6, 22, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[44821, 914, 5128, 88, 1299, "Input"],
Cell[49952, 1004, 355, 5, 22, "Message"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

